for _, animation in ipairs(data.raw["player"]["player"]["animations"]) do
  if animation.armors then
    for _, armor in ipairs(animation.armors) do
      if armor == "power-armor-mk2" then
        animation.armors[#animation.armors + 1] = "nuclear-fission-armor"
        animation.armors[#animation.armors + 1] = "nuclear-fission-armor-mk2"
        break
      end
    end
  end
end

data:extend(
{
  {
    type = "armor",
    name = "nuclear-fission-armor",
    icon = "__NuclearFissionArmor__/graphics/icons/nuclear-fission-armor.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    resistances =
    {
      {
        type = "physical",
        decrease = 14,
        percent = 50
      },
      {
        type = "acid",
        decrease = 14,
        percent = 50
      },
      {
        type = "explosion",
        decrease = 70,
        percent = 60
      },
      {
        type = "fire",
        decrease = 0,
        percent = 80
      }
    },
    durability = 30000,
    subgroup = "armor",
    order = "g[nuclear-fission-armor]",
    stack_size = 1,
    equipment_grid = "mk1-equipment-grid",
    inventory_size_bonus = 40
  },
  {
    type = "armor",
    name = "nuclear-fission-armor-mk2",
    icon = "__NuclearFissionArmor__/graphics/icons/nuclear-fission-armor-mk2.png",
	icon_size = 32,
    flags = {"goes-to-main-inventory"},
    resistances =
    {
      {
        type = "physical",
        decrease = 18,
        percent = 60
      },
      {
        type = "acid",
        decrease = 18,
        percent = 60
      },
      {
        type = "explosion",
        decrease = 80,
        percent = 70
      },
      {
        type = "fire",
        decrease = 0,
        percent = 90
      }
    },
    durability = 50000,
    subgroup = "armor",
    order = "h[nuclear-fission-armor-mk2]",
    stack_size = 1,
    equipment_grid = "mk2-equipment-grid",
    inventory_size_bonus = 50
  },
}
)