data:extend({

--Recipe
  {
    type = "recipe",
    name = "hypers-accumulator-mk1",
    normal =
    {
      energy_required = 15,
	  enabled = false,
      ingredients =
      {
      {"accumulator", 8},
	  {"iron-plate", 5}
      },
      result = "hypers-accumulator-mk1"
    },
    expensive =
    {
      energy_required = 20,
	  enabled = false,
      ingredients =
      {
      {"accumulator", 8},
	  {"iron-plate", 10}
      },
      result = "hypers-accumulator-mk1"
    }
  },
    {
    type = "recipe",
    name = "hypers-accumulator-mk2",
    normal =
    {
      energy_required = 20,
	  enabled = false,
      ingredients =
      {
      {"hypers-accumulator-mk1", 4},
	  {"iron-plate", 5}
      },
      result = "hypers-accumulator-mk2"
    },
    expensive =
    {
      energy_required = 30,
	  enabled = false,
      ingredients =
      {
      {"hypers-accumulator-mk1", 4},
	  {"iron-plate", 20}
      },
      result = "hypers-accumulator-mk2"
    }
  },

--Item
  {
    type = "item",
    name = "hypers-accumulator-mk1",
    icon = "__base__/graphics/icons/accumulator.png",
	icon_size = 32,
    flags = {"goes-to-quickbar"},
    subgroup = "energy",
    order = "e[accumulator]-b[accumulatorh1]",
    place_result = "hypers-accumulator-mk1",
    stack_size = 50
  },
    {
    type = "item",
    name = "hypers-accumulator-mk2",
    icon = "__base__/graphics/icons/accumulator.png",
	icon_size = 32,
    flags = {"goes-to-quickbar"},
    subgroup = "energy",
    order = "e[accumulator]-c[accumulatorh2]",
    place_result = "hypers-accumulator-mk2",
    stack_size = 50
  },

--Entity
  {
    type = "accumulator",
    name = "hypers-accumulator-mk1",
    icon = "__base__/graphics/icons/accumulator.png",
	icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "hypers-accumulator-mk1"},
    max_health = 200,
    corpse = "medium-remnants",
    collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-1, -1}, {1, 1}},
    energy_source =
    {
      type = "electric",
      buffer_capacity = "45MJ",
      usage_priority = "terciary",
      input_flow_limit = "2500kW",
      output_flow_limit = "2500kW"
    },
    picture =
    {
      filename = "__base__/graphics/entity/accumulator/accumulator.png",
      priority = "extra-high",
      width = 124,
      height = 103,
      shift = {0.6875, -0.203125}
    },
    charge_animation =
    {
      filename = "__base__/graphics/entity/accumulator/accumulator-charge-animation.png",
      width = 138,
      height = 135,
      line_length = 8,
      frame_count = 24,
      shift = {0.46875, -0.640625},
      animation_speed = 0.5
    },

    universal_base =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04a-base-sequence.png",
      line_length = 8,
      width = 52,
      height = 50,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0, 1),
    },

    universal_wire =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04c-wire-sequence.png",
      line_length = 8,
      width = 62,
      height = 58,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0.5, 0),
    },

    universal_red_led =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04i-red-LED-sequence.png",
      line_length = 8,
      width = 48,
      height = 46,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0, 0),
    },

    universal_green_led =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04h-green-LED-sequence.png",
      line_length = 8,
      width = 48,
      height = 46,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0, 0),
    },

    universal_blue_led =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04f-blue-LED-off-sequence.png",
      line_length = 8,
      width = 46,
      height = 46,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0, 0),
    },

    universal_base_shadow =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04b-base-shadow-sequence.png",
      line_length = 8,
      width = 62,
      height = 46,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(3, 2.5),
    },

    charge_cooldown = 30,
    charge_light = {intensity = 0.3, size = 7, color = {r = 1.0, g = 1.0, b = 1.0}},
    discharge_animation =
    {
      filename = "__base__/graphics/entity/accumulator/accumulator-discharge-animation.png",
      width = 147,
      height = 128,
      line_length = 8,
      frame_count = 24,
      shift = {0.390625, -0.53125},
      animation_speed = 0.5
    },
    discharge_cooldown = 60,
    discharge_light = {intensity = 0.7, size = 7, color = {r = 1.0, g = 1.0, b = 1.0}},
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/accumulator-working.ogg",
        volume = 1
      },
      idle_sound = {
        filename = "__base__/sound/accumulator-idle.ogg",
        volume = 0.4
      },
      max_sounds_per_type = 5
    },

    circuit_wire_connection_point = circuit_connector_definitions["accumulator"].points,
    circuit_connector_sprites = circuit_connector_definitions["accumulator"].sprites,
    circuit_wire_max_distance = default_circuit_wire_max_distance,

    default_output_signal = {type = "virtual", name = "signal-A"}
  },
    {
    type = "accumulator",
    name = "hypers-accumulator-mk2",
    icon = "__base__/graphics/icons/accumulator.png",
	icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "hypers-accumulator-mk2"},
    max_health = 300,
    corpse = "medium-remnants",
    collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-1, -1}, {1, 1}},
    energy_source =
    {
      type = "electric",
      buffer_capacity = "200MJ",
      usage_priority = "terciary",
      input_flow_limit = "10000kW",
      output_flow_limit = "10000kW"
    },
    picture =
    {
      filename = "__base__/graphics/entity/accumulator/accumulator.png",
      priority = "extra-high",
      width = 124,
      height = 103,
      shift = {0.6875, -0.203125}
    },
    charge_animation =
    {
      filename = "__base__/graphics/entity/accumulator/accumulator-charge-animation.png",
      width = 138,
      height = 135,
      line_length = 8,
      frame_count = 24,
      shift = {0.46875, -0.640625},
      animation_speed = 0.5
    },

    universal_base =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04a-base-sequence.png",
      line_length = 8,
      width = 52,
      height = 50,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0, 1),
    },

    universal_wire =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04c-wire-sequence.png",
      line_length = 8,
      width = 62,
      height = 58,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0.5, 0),
    },

    universal_red_led =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04i-red-LED-sequence.png",
      line_length = 8,
      width = 48,
      height = 46,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0, 0),
    },

    universal_green_led =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04h-green-LED-sequence.png",
      line_length = 8,
      width = 48,
      height = 46,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0, 0),
    },

    universal_blue_led =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04f-blue-LED-off-sequence.png",
      line_length = 8,
      width = 46,
      height = 46,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(0, 0),
    },

    universal_base_shadow =
    {
      filename = "__base__/graphics/entity/__temp/hr-ccm-universal-04b-base-shadow-sequence.png",
      line_length = 8,
      width = 62,
      height = 46,
      frame_count = 32,
      scale = 0.5,
      shift = util.by_pixel(3, 2.5),
    },

    charge_cooldown = 30,
    charge_light = {intensity = 0.3, size = 7, color = {r = 1.0, g = 1.0, b = 1.0}},
    discharge_animation =
    {
      filename = "__base__/graphics/entity/accumulator/accumulator-discharge-animation.png",
      width = 147,
      height = 128,
      line_length = 8,
      frame_count = 24,
      shift = {0.390625, -0.53125},
      animation_speed = 0.5
    },
    discharge_cooldown = 60,
    discharge_light = {intensity = 0.7, size = 7, color = {r = 1.0, g = 1.0, b = 1.0}},
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/accumulator-working.ogg",
        volume = 1
      },
      idle_sound = {
        filename = "__base__/sound/accumulator-idle.ogg",
        volume = 0.4
      },
      max_sounds_per_type = 5
    },

    circuit_wire_connection_point = circuit_connector_definitions["accumulator"].points,
    circuit_connector_sprites = circuit_connector_definitions["accumulator"].sprites,
    circuit_wire_max_distance = default_circuit_wire_max_distance,

    default_output_signal = {type = "virtual", name = "signal-A"}
  },


  ---technology
  {
    type = "technology",
    name = "hypers-accumulator-mk1",
    icon = "__base__/graphics/technology/electric-energy-acumulators.png",
	icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "hypers-accumulator-mk1"
      }
    },
    prerequisites = {"electric-energy-accumulators-1", "battery"},
    unit =
    {
      count = 150,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},		
		{"science-pack-3", 1}
      },
      time = 5
    },
    order = "c-e-a",
  },
    {
    type = "technology",
    name = "hypers-accumulator-mk2",
    icon = "__base__/graphics/technology/electric-energy-acumulators.png",
	icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "hypers-accumulator-mk2"
      }
    },
    prerequisites = {"hypers-accumulator-mk1"},
    unit =
    {
      count = 300,
      ingredients =
      {
        {"production-science-pack", 1},
        {"high-tech-science-pack", 1},
        {"science-pack-1", 1},
        {"science-pack-2", 1},
		{"science-pack-3", 1}
      },
      time = 60
    },
    order = "c-e-a",
  },
  
  
})