data:extend({

--Recipe
  {
    type = "recipe",
    name = "hyper-solar-panel-equipment-mk2",
    enabled = false,
    energy_required = 15,
    ingredients =
    {
      {"solar-panel-equipment", 10},
      {"advanced-circuit", 5},
    },
    result = "hyper-solar-panel-equipment-mk2"
  },
  {
    type = "recipe",
    name = "hyper-energy-shield-mk3-equipment",
    enabled = false,
    energy_required = 10,
    ingredients =
    {
      {"energy-shield-mk2-equipment", 10},
      {"processing-unit", 20}
    },
    result = "hyper-energy-shield-mk3-equipment"
  },
    {
    type = "recipe",
    name = "hyper-battery-mk3-equipment",
    enabled = false,
    energy_required = 10,
    ingredients =
    {
      {"battery-mk2-equipment", 10},
      {"processing-unit", 40}
    },
    result = "hyper-battery-mk3-equipment"
  },
   {
    type = "recipe",
    name = "hyper-fusion-reactor-equipment-mk2",
    enabled = false,
    energy_required = 10,
    ingredients =
    {
      {"uranium-235", 25},
	  {"fusion-reactor-equipment", 1}
    },
    result = "hyper-fusion-reactor-equipment-mk2"
  },
    {
    type = "recipe",
    name = "hyper-personal-laser-defense-equipment-mk2",
    enabled = false,
    energy_required = 10,
    ingredients =
    {
      {"processing-unit", 20},
      {"steel-plate", 20},
      {"personal-laser-defense-equipment", 10}
    },
    result = "hyper-personal-laser-defense-equipment-mk2"
  },
    {
    type = "recipe",
    name = "hyper-exoskeleton-equipment-mk2",
    enabled = false,
    energy_required = 10,
    ingredients =
    {
      {"processing-unit", 30},
      {"exoskeleton-equipment", 10},
      {"steel-plate", 20},
    },
    result = "hyper-exoskeleton-equipment-mk2"
  },
--Item
    {
    type = "item",
    name = "hyper-solar-panel-equipment-mk2",
    icon = "__base__/graphics/icons/solar-panel-equipment.png",
	icon_size = 32,
    placed_as_equipment_result = "hyper-solar-panel-equipment-mk2",
    flags = {"goes-to-main-inventory"},
    subgroup = "equipment",
    order = "a[energy-source]-a[solar-panel-hyper]",
    stack_size = 20
  },
  {
    type = "item",
    name = "hyper-fusion-reactor-equipment-mk2",
    icon = "__hyperkiller-addons__/graphics/equipment/fusion-reactor-equipment-mk2.png",
	icon_size = 32,
    placed_as_equipment_result = "hyper-fusion-reactor-equipment-mk2",
    flags = {"goes-to-main-inventory"},
    subgroup = "equipment",
    order = "a[energy-source]-c[fusion-reactor-hyper]",
    stack_size = 20
  },
    {
    type = "item",
    name = "hyper-energy-shield-mk3-equipment",
    icon = "__base__/graphics/icons/energy-shield-mk2-equipment.png",
	icon_size = 32,
    placed_as_equipment_result = "hyper-energy-shield-mk3-equipment",
    flags = {"goes-to-main-inventory"},
    subgroup = "equipment",
    order = "b[shield]-c[energy-shield-equipment-mk2-hyper]",
    stack_size = 50,
    default_request_amount = 10
  },
    {
    type = "item",
    name = "hyper-battery-mk3-equipment",
    icon = "__hyperkiller-addons__/graphics/icons/battery-mk3-equipment.png",
	icon_size = 32,
    placed_as_equipment_result = "hyper-battery-mk3-equipment",
    flags = {"goes-to-main-inventory"},
    subgroup = "equipment",
    order = "c[battery]-c[battery-equipment-mk2-hyper]",
    stack_size = 50,
    default_request_amount = 10
  },
    {
    type = "item",
    name = "hyper-personal-laser-defense-equipment-mk2",
    icon = "__base__/graphics/icons/personal-laser-defense-equipment.png",
	icon_size = 32,
    placed_as_equipment_result = "hyper-personal-laser-defense-equipment-mk2",
    flags = {"goes-to-main-inventory"},
    subgroup = "equipment",
    order = "d[active-defense]-a[personal-laser-defense-equipment-hyper]",
    stack_size = 20
  },
    {
    type = "item",
    name = "hyper-exoskeleton-equipment-mk2",
    icon = "__base__/graphics/icons/exoskeleton-equipment.png",
	icon_size = 32,
    placed_as_equipment_result = "hyper-exoskeleton-equipment-mk2",
    flags = {"goes-to-main-inventory"},
    subgroup = "equipment",
    order = "e[exoskeleton]-b[exoskeleton-equipment-hyper]",
    stack_size = 10
  },
--Entity

--Equipment
 {
    type = "solar-panel-equipment",
    name = "hyper-solar-panel-equipment-mk2",
    sprite =
    {
      filename = "__base__/graphics/equipment/solar-panel-equipment.png",
      width = 32,
      height = 32,
      priority = "medium"
    },
    shape =
    {
      width = 1,
      height = 1,
      type = "full"
    },
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output"
    },
    power = "100kW",
    categories = {"armor"}
  },
  {
    type = "energy-shield-equipment",
    name = "hyper-energy-shield-mk3-equipment",
    sprite =
    {
      filename = "__base__/graphics/equipment/energy-shield-mk2-equipment.png",
      width = 64,
      height = 64,
      priority = "medium"
    },
    shape =
    {
      width = 2,
      height = 2,
      type = "full"
    },
    max_shield_value = 450,
    energy_source =
    {
      type = "electric",
      buffer_capacity = "600kJ",
      input_flow_limit = "600kW",
      usage_priority = "primary-input"
    },
    energy_per_shield = "40kJ",
    categories = {"armor"}
  },
    {
    type = "battery-equipment",
    name = "hyper-battery-mk3-equipment",
    sprite =
    {
      filename = "__hyperkiller-addons__/graphics/equipment/battery-mk3-equipment.png",
      width = 32,
      height = 64,
      priority = "medium"
    },
    shape =
    {
      width = 1,
      height = 2,
      type = "full"
    },
    energy_source =
    {
      type = "electric",
      buffer_capacity = "500MJ",
      input_flow_limit = "3GW",
      output_flow_limit = "3GW",
      usage_priority = "terciary"
    },
    categories = {"armor"}
  },
    {
    type = "generator-equipment",
    name = "hyper-fusion-reactor-equipment-mk2",
    sprite =
    {
      filename = "__hyperkiller-addons__/graphics/equipment/fusion-reactor-equipment-mk2.png",
      width = 128,
      height = 128,
      priority = "medium"
    },
    shape =
    {
      width = 4,
      height = 4,
      type = "full"
    },
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output"
    },
    power = "3000kW",
    categories = {"armor"}
  },
    {
    type = "active-defense-equipment",
    name = "hyper-personal-laser-defense-equipment-mk2",
    sprite =
    {
      filename = "__base__/graphics/equipment/personal-laser-defense-equipment.png",
      width = 64,
      height = 64,
      priority = "medium"
    },
    shape =
    {
      width = 2,
      height = 2,
      type = "full"
    },
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
      buffer_capacity = "600kJ"
    },
    attack_parameters =
    {
      type = "projectile",
      ammo_category = "electric",
      cooldown = 15,
      damage_modifier = 20,
      projectile_center = {0, 0},
      projectile_creation_distance = 0.6,
      range = 22,
      sound = make_laser_sounds(),
      ammo_type =
      {
        type = "projectile",
        category = "electric",
        energy_consumption = "200kJ",
        projectile = "laser",
        speed = 1,
        action =
        {
          {
            type = "direct",
            action_delivery =
            {
              {
                type = "projectile",
                projectile = "laser",
                starting_speed = 0.28
              }
            }
          }
        }
      }
    },
    automatic = true,
    categories = {"armor"}
  },
    {
    type = "movement-bonus-equipment",
    name = "hyper-exoskeleton-equipment-mk2",
    sprite =
    {
      filename = "__base__/graphics/equipment/exoskeleton-equipment.png",
      width = 64,
      height = 128,
      priority = "medium"
    },
    shape =
    {
      width = 2,
      height = 4,
      type = "full"
    },
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input"
    },
    energy_consumption = "400kW",
    movement_bonus = 0.6,
    categories = {"armor"}
  },
---technology-----------------------------------------
   {
    type = "technology",
    name = "hyper-Advanced-modular-equipment-fus",
    icon = "__base__/graphics/technology/fusion-reactor-equipment.png",
	icon_size = 128,
    prerequisites = {"fusion-reactor-equipment"},
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "hyper-fusion-reactor-equipment-mk2"
      },
    },
    unit =
    {
      count = 250,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}, {"military-science-pack", 1}, {"high-tech-science-pack", 1}},
      time = 30
    },
    order = "g-l"
  },
   {
    type = "technology",
    name = "hyper-Advanced-modular-equipment-shi",
    icon = "__base__/graphics/technology/energy-shield-mk2-equipment.png",
	icon_size = 128,
    prerequisites = {"energy-shield-mk2-equipment"},
    effects =
    {
	  {
        type = "unlock-recipe",
        recipe = "hyper-energy-shield-mk3-equipment"
      },
    },
    unit =
    {
      count = 150,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}, {"military-science-pack", 1}, {"high-tech-science-pack", 1}},
      time = 30
    },
    order = "g-l"
  },
 {
    type = "technology",
    name = "hyper-Advanced-modular-equipment-bat",
    icon = "__base__/graphics/technology/battery-mk2-equipment.png",
	icon_size = 128,
    prerequisites = {"battery-mk2-equipment"},
    effects =
    {
	  {
        type = "unlock-recipe",
        recipe = "hyper-battery-mk3-equipment"
      },
    },
    unit =
    {
      count = 150,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}, {"high-tech-science-pack", 1}},
      time = 30
    },
    order = "g-l"
  },
   {
    type = "technology",
    name = "hyper-Advanced-modular-equipment-per",
    icon = "__base__/graphics/technology/personal-laser-defense-equipment.png",
	icon_size = 128,
    prerequisites = {"personal-laser-defense-equipment"},
    effects =
    {
	  {
        type = "unlock-recipe",
        recipe = "hyper-personal-laser-defense-equipment-mk2"
      },
    },
    unit =
    {
      count = 150,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}, {"military-science-pack", 1}, {"high-tech-science-pack", 1}},
      time = 30
    },
    order = "g-l"
  }, 
     {
    type = "technology",
    name = "hyper-Advanced-modular-equipment-exo",
    icon = "__base__/graphics/technology/exoskeleton-equipment.png",
	icon_size = 128,
    prerequisites = {"exoskeleton-equipment"},
    effects =
    {

	  {
        type = "unlock-recipe",
        recipe = "hyper-exoskeleton-equipment-mk2"
      },
    },
    unit =
    {
      count = 150,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}, {"high-tech-science-pack", 1}},
      time = 30
    },
    order = "g-l"
  },
       {
    type = "technology",
    name = "hyper-Advanced-modular-equipment-sol",
    icon = "__base__/graphics/technology/solar-panel-equipment.png",
	icon_size = 128,
    prerequisites = {"solar-panel-equipment"},
    effects =
    {

	  {
        type = "unlock-recipe",
        recipe = "hyper-solar-panel-equipment-mk2"
      },
    },
    unit =
    {
      count = 150,
      ingredients = {{"science-pack-1", 1}, {"science-pack-2", 1}, {"science-pack-3", 1}, {"production-science-pack", 1}},
      time = 30
    },
    order = "g-l"
  },

  
})