data:extend({

--Recipe
  {
    type = "recipe",
    name = "hypers-solar-panel-mk1",
    normal =
    {
      energy_required = 10,
	  enabled = false,
      ingredients =
      {
		{"solar-panel", 8},
		{"steel-plate", 5},
		{"electronic-circuit", 10},
		{"copper-plate", 5},
      },
      result = "hypers-solar-panel-mk1"
    },
    expensive =
    {
      energy_required = 25,
	  enabled = false,
      ingredients =
      {
		{"solar-panel", 8},
		{"steel-plate", 10},
		{"electronic-circuit", 20},
		{"copper-plate", 10},
      },
      result = "hypers-solar-panel-mk1"
    }
  },
  {
    type = "recipe",
    name = "hypers-solar-panel-mk2",
    normal =
    {
      energy_required = 30,
	  enabled = false,
      ingredients =
    {
	  {"hypers-solar-panel-mk1", 4},
      {"steel-plate", 10},
      {"electronic-circuit", 10},
      {"copper-plate", 10},
      {"advanced-circuit", 10},	  
      {"processing-unit", 5},
    },
      result = "hypers-solar-panel-mk2"
    },
    expensive =
    {
      energy_required = 80,
	  enabled = false,
      ingredients =
    {
	  {"hypers-solar-panel-mk1", 4},
      {"steel-plate", 20},
      {"electronic-circuit", 20},
      {"copper-plate", 20},
      {"advanced-circuit", 20},	  
      {"processing-unit", 10},
    },
      result = "hypers-solar-panel-mk2"
    }
  },

--Item
  {
    type = "item",
    name = "hypers-solar-panel-mk1",
    icon = "__base__/graphics/icons/solar-panel.png",
	icon_size = 32,
    flags = {"goes-to-quickbar"},
    subgroup = "energy",
    order = "d[solar-panel]-b[solar-panelh1]",
    place_result = "hypers-solar-panel-mk1",
    stack_size = 50
  },
      {
    type = "item",
    name = "hypers-solar-panel-mk2",
    icon = "__base__/graphics/icons/solar-panel.png",
	icon_size = 32,
    flags = {"goes-to-quickbar"},
    subgroup = "energy",
    order = "d[solar-panel]-f[solar-panelh2]",
    place_result = "hypers-solar-panel-mk2",
    stack_size = 50
  },

--Entity
    {
    type = "solar-panel",
    name = "hypers-solar-panel-mk1",
    icon = "__base__/graphics/icons/solar-panel.png",
	icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "hypers-solar-panel-mk1"},
    max_health = 200,
    corpse = "big-remnants",
    collision_box = {{-1.4, -1.4}, {1.4, 1.4}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    energy_source =
    {
      type = "electric",
      usage_priority = "solar"
    },
   picture =
    {
      layers =
      {
        {
          filename = "__base__/graphics/entity/solar-panel/solar-panel.png",
          priority = "high",
          width = 116,
          height = 112,
          shift = util.by_pixel(-3, 3),
          hr_version = {
            filename = "__base__/graphics/entity/solar-panel/hr-solar-panel.png",
            priority = "high",
            width = 230,
            height = 224,
            shift = util.by_pixel(-3, 3.5),
            scale = 0.5
          }
        },
        {
          filename = "__base__/graphics/entity/solar-panel/solar-panel-shadow.png",
          priority = "high",
          width = 112,
          height = 90,
          shift = util.by_pixel(10, 6),
          draw_as_shadow = true,
          hr_version = {
            filename = "__base__/graphics/entity/solar-panel/hr-solar-panel-shadow.png",
            priority = "high",
            width = 220,
            height = 180,
            shift = util.by_pixel(9.5, 6),
            draw_as_shadow = true,
            scale = 0.5
          }
        }
      }
    },
    overlay =
    {
      layers =
      {
        {
          filename = "__base__/graphics/entity/solar-panel/solar-panel-shadow-overlay.png",
          priority = "high",
          width = 108,
          height = 90,
          shift = util.by_pixel(11, 6),
          hr_version = {
            filename = "__base__/graphics/entity/solar-panel/hr-solar-panel-shadow-overlay.png",
            priority = "high",
            width = 214,
            height = 180,
            shift = util.by_pixel(10.5, 6),
            scale = 0.5
          }
        }
      }
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    production = "600kW"
  },
    {
    type = "solar-panel",
    name = "hypers-solar-panel-mk2",
    icon = "__base__/graphics/icons/solar-panel.png",
	icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "hypers-solar-panel-mk2"},
    max_health = 300,
    corpse = "big-remnants",
    collision_box = {{-1.4, -1.4}, {1.4, 1.4}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    energy_source =
    {
      type = "electric",
      usage_priority = "solar"
    },
   picture =
    {
      layers =
      {
        {
          filename = "__base__/graphics/entity/solar-panel/solar-panel.png",
          priority = "high",
          width = 116,
          height = 112,
          shift = util.by_pixel(-3, 3),
          hr_version = {
            filename = "__base__/graphics/entity/solar-panel/hr-solar-panel.png",
            priority = "high",
            width = 230,
            height = 224,
            shift = util.by_pixel(-3, 3.5),
            scale = 0.5
          }
        },
        {
          filename = "__base__/graphics/entity/solar-panel/solar-panel-shadow.png",
          priority = "high",
          width = 112,
          height = 90,
          shift = util.by_pixel(10, 6),
          draw_as_shadow = true,
          hr_version = {
            filename = "__base__/graphics/entity/solar-panel/hr-solar-panel-shadow.png",
            priority = "high",
            width = 220,
            height = 180,
            shift = util.by_pixel(9.5, 6),
            draw_as_shadow = true,
            scale = 0.5
          }
        }
      }
    },
    overlay =
    {
      layers =
      {
        {
          filename = "__base__/graphics/entity/solar-panel/solar-panel-shadow-overlay.png",
          priority = "high",
          width = 108,
          height = 90,
          shift = util.by_pixel(11, 6),
          hr_version = {
            filename = "__base__/graphics/entity/solar-panel/hr-solar-panel-shadow-overlay.png",
            priority = "high",
            width = 214,
            height = 180,
            shift = util.by_pixel(10.5, 6),
            scale = 0.5
          }
        }
      }
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    production = "2500kW"
  },
  
  ---technology
  {
    type = "technology",
    name = "hypers-solar-panel-mk1",
    icon = "__base__/graphics/technology/solar-energy.png",
	icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "hypers-solar-panel-mk1"
      },
    },
	prerequisites = {"steel-processing","solar-energy"},
    unit =
    {
      count = 200,
      ingredients = 
	  {
        {"science-pack-1", 1},
        {"science-pack-2", 1}
	  },
      time = 5
    },
    order = "c-a"
  },
  {
    type = "technology",
    name = "hypers-solar-panel-mk2",
    icon = "__base__/graphics/technology/solar-energy.png",
	icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "hypers-solar-panel-mk2"
      },
    },
	prerequisites = {"hypers-solar-panel-mk1"},
    unit =
    {
      count = 400,
      ingredients = 
	  {
		{"science-pack-1", 2},
		{"science-pack-2", 2},
		{"science-pack-3", 1},
        {"production-science-pack", 1},
        {"high-tech-science-pack", 1},
	  },
      time = 60
    },
    order = "c-a"
  },
  
  
})